

#ifndef _PIDIO_DLL_H_
#define _PIDIO_DLL_H_


#ifdef PIDIO_DLL_EXPORTS
#define PIDIO_DLL_API __declspec(dllexport)
#else
#define PIDIO_DLL_API __declspec(dllimport)
#endif


//----------------------------------------------------------------
//					`
//----------------------------------------------------------------

// foCXhc
#define ID_PD5006P			0xA0C6		// PD5006P@͂US_		
#define ID_PD5106P			0xA0C7		// PD5106P@o͂US_		
#define ID_PD5206P			0xA0C8		// PD5206P@͂RQ_^o͂RQ_		
#define ID_PD5306P			0xA0C9		// PD5306P@oUS_		

// bZ[W
#define WM_INTRPT		(WM_USER + 0x100)	// 荞ݒʒmbZ[W

// G[R[h
#define ERR_NO_SUPPORT		0x100		// Y{[hł̓T|[gĂȂ֐R[
#define ERR_PORT_NO			0x101		// w肵|[gԍԈĂ
#define EER_INTRPT_OPEN		0x102		// Y{[h͊ɕʃAvݎgpI[vsĂ܂
										// P{[hɑ΂Ċ荞ݎgpI[vł̂́AP̃Av݂̂ł

#define ERR_ALREADY_OPEN	0x200		// w肵{[h͊ɃI[vł
#define ERR_OPEN_BOARD		0x201		// {[hI[vł܂iw肵foCXhcAXCb`ԍԈĂꍇj
#define ERR_ACCESS_BOARD	0x202		// w肵{[hɃANZXł܂iw肵{[hnhԈĂꍇj
#define ERR_ALLOC_MEM		0x203		// mۂł܂
#define ERR_INTRPT_INVALID	0x204		// I[vɊ荞ݏgpȂݒɂĂׁAw֐sł܂
#define ERR_END_THREAD		0x205		// XbhIł܂ł

#define ERR_PARAM			0x300		// ̒lԈĂ܂


//----------------------------------------------------------------
//					֐錾
//----------------------------------------------------------------

PIDIO_DLL_API BOOL __stdcall Dio_Open(USHORT DeviceID, USHORT SwitchNo, BOOL IntrptFlg, HANDLE* phBoard);	// {[hI[v
PIDIO_DLL_API BOOL __stdcall Dio_Close(HANDLE hBoard);														// {[hN[Y
PIDIO_DLL_API BOOL __stdcall Dio_CloseAll();																// S{[hN[Y
PIDIO_DLL_API BOOL __stdcall Dio_SetEventFunc(HANDLE hBoard, void (CALLBACK* UserFunc)(LPVOID lpParam), LPVOID lpParam);	// 荞ݒʒmݒi[U[֐gpj
PIDIO_DLL_API BOOL __stdcall Dio_SetEventMsg(HANDLE hBoard, HWND hWnd, LPARAM lParam);										// 荞ݒʒmݒibZ[Wgpj
PIDIO_DLL_API BOOL __stdcall Dio_ResetEvent(HANDLE hBoard);																	// 荞ݒʒmݒ

// [hݒ
PIDIO_DLL_API BOOL __stdcall Dio_SetIoDir(HANDLE hBoard, ULONG WtData1, ULONG WtData2);						// ́^o͂̎w
PIDIO_DLL_API BOOL __stdcall Dio_SetInputLogic(HANDLE hBoard, ULONG WtData1, ULONG WtData2);				// ͘_ݒ
PIDIO_DLL_API BOOL __stdcall Dio_SetInputFilter(HANDLE hBoard, ULONG WtData);								// ̓tB^w
PIDIO_DLL_API BOOL __stdcall Dio_SetFilterTime(HANDLE hBoard, ULONG Filter1, ULONG Filter2, ULONG Filter3);	// tB^萔̐ݒ
PIDIO_DLL_API BOOL __stdcall Dio_SetTimer(HANDLE hBoard, ULONG TimerNo, ULONG TimerValue, ULONG Unit);		// ^C}lݒ
PIDIO_DLL_API BOOL __stdcall Dio_SetInTransitionMode(HANDLE hBoard, ULONG WtData1, ULONG WtData2);			// ͕ωLݒ
PIDIO_DLL_API BOOL __stdcall Dio_SetInTransitionDir(HANDLE hBoard, ULONG WtData1, ULONG WtData2);			// ͕ωݒ
PIDIO_DLL_API BOOL __stdcall Dio_SetStrobeDir(HANDLE hBoard, ULONG Instb, ULONG Otstb);						// OXg[uMωݒ
PIDIO_DLL_API BOOL __stdcall Dio_SetSmlInStbCmd(HANDLE hBoard, ULONG Enabled);								// ͓b`ݒiXg[uA߁j
PIDIO_DLL_API BOOL __stdcall Dio_SetSmlInTimer(HANDLE hBoard, ULONG Enabled);								// ͓b`ݒi^C}j
PIDIO_DLL_API BOOL __stdcall Dio_SetSmlOutStbCmd(HANDLE hBoard, ULONG Enabled);								// o͓ZbgݒiXg[uA߁j
PIDIO_DLL_API BOOL __stdcall Dio_SetSmlOutTimer(HANDLE hBoard, ULONG Enabled);								// o͓Zbgݒi^C}j
PIDIO_DLL_API BOOL __stdcall Dio_SetIntrptMode(HANDLE hBoard, ULONG IntrptMode);							// 荞ݐݒ

// [hݒǂݏo
PIDIO_DLL_API BOOL __stdcall Dio_GetIoDir(HANDLE hBoard, ULONG* pRdData1, ULONG* pRdData2);					// ́^o͂̎wǂݏo
PIDIO_DLL_API BOOL __stdcall Dio_GetInputLogic(HANDLE hBoard, ULONG* pRdData1, ULONG* pRdData2);			// ͘_ݒǂݏo
PIDIO_DLL_API BOOL __stdcall Dio_GetInputFilter(HANDLE hBoard, ULONG* pRdData);								// ̓tB^wǂݏo
PIDIO_DLL_API BOOL __stdcall Dio_GetFilterTime(HANDLE hBoard, ULONG* pFilter1, ULONG* pFilter2, ULONG* pFilter3);	// tB^萔̐ݒǂݏo
PIDIO_DLL_API BOOL __stdcall Dio_GetTimer(HANDLE hBoard, ULONG TimerNo, ULONG* pTimerValue, ULONG* pUnit);			// ^C}lݒǂݏo
PIDIO_DLL_API BOOL __stdcall Dio_GetInTransitionMode(HANDLE hBoard, ULONG* pRdData1, ULONG* pRdData2);		// ͕ωLݒǂݏo 
PIDIO_DLL_API BOOL __stdcall Dio_GetInTransitionDir(HANDLE hBoard, ULONG* pRdData1, ULONG* pRdData2);		// ͕ωݒǂݏo
PIDIO_DLL_API BOOL __stdcall Dio_GetStrobeDir(HANDLE hBoard, ULONG* pInstb, ULONG* pOtstb);					// OXg[uMωݒǂݏo
PIDIO_DLL_API BOOL __stdcall Dio_GetSmlInStbCmd(HANDLE hBoard, ULONG* pEnabled);							// ͓b`ݒǂݏoiXg[uA߁j
PIDIO_DLL_API BOOL __stdcall Dio_GetSmlInTimer(HANDLE hBoard, ULONG* pEnabled);								// ͓b`ݒǂݏoi^C}j
PIDIO_DLL_API BOOL __stdcall Dio_GetSmlOutStbCmd(HANDLE hBoard, ULONG* pEnabled);							// o͓ZbgݒǂݏoiXg[uA߁j
PIDIO_DLL_API BOOL __stdcall Dio_GetSmlOutTimer(HANDLE hBoard, ULONG* pEnabled);							// o͓Zbgݒǂݏoi^C}j
PIDIO_DLL_API BOOL __stdcall Dio_GetIntrptMode(HANDLE hBoard, ULONG* pIntrptMode);							// 荞ݐݒǂݏo

// 
PIDIO_DLL_API BOOL __stdcall Dio_In_1Bit(HANDLE hBoard, ULONG SignalNo, ULONG* pReadData);					// PrbǵiP_j
PIDIO_DLL_API BOOL __stdcall Dio_In_1Byte(HANDLE hBoard, ULONG PortNo, ULONG* pReadData);					// PoCǵiW_j
PIDIO_DLL_API BOOL __stdcall Dio_In_2Byte(HANDLE hBoard, ULONG PortNo, ULONG* pReadData);					// QoCǵiPU_j
PIDIO_DLL_API BOOL __stdcall Dio_In_4Byte(HANDLE hBoard, ULONG PortNo, ULONG* pReadData);					// SoCǵiRQ_j
PIDIO_DLL_API BOOL __stdcall Dio_In_8Byte(HANDLE hBoard, ULONG PortNo, ULONG* pReadData1, ULONG* pReadData2);// WoCǵiUS_j
PIDIO_DLL_API BOOL __stdcall Dio_In_nBit(HANDLE hBoard, ULONG Cnt, ULONG* pSignalNoArray, ULONG* pRdDataArray);	// rbg
PIDIO_DLL_API BOOL __stdcall Dio_In_nByte(HANDLE hBoard, ULONG Cnt, ULONG* pPortNoArray, ULONG* pRdDataArray);	// oCg

// o
PIDIO_DLL_API BOOL __stdcall Dio_Out_1Bit(HANDLE hBoard, ULONG SignalNo, ULONG WriteData);					// PrbgóiP_j
PIDIO_DLL_API BOOL __stdcall Dio_Out_1Byte(HANDLE hBoard, ULONG PortNo, ULONG WriteData);					// PoCgóiW_j
PIDIO_DLL_API BOOL __stdcall Dio_Out_2Byte(HANDLE hBoard, ULONG PortNo, ULONG WriteData);					// QoCgóiPU_j
PIDIO_DLL_API BOOL __stdcall Dio_Out_4Byte(HANDLE hBoard, ULONG PortNo, ULONG WriteData);					// SoCgóiRQ_j
PIDIO_DLL_API BOOL __stdcall Dio_Out_8Byte(HANDLE hBoard, ULONG PortNo, ULONG WriteData1, ULONG WriteData2);// WoCgóiUS_j
PIDIO_DLL_API BOOL __stdcall Dio_Out_nBit(HANDLE hBoard, ULONG Cnt, ULONG* pSignalNoArray, ULONG* pWtDataArray);// rbgo
PIDIO_DLL_API BOOL __stdcall Dio_Out_nByte(HANDLE hBoard, ULONG Cnt, ULONG* pPortNoArray, ULONG* pWtDataArray); // oCgo

// f[^ǂݏo
PIDIO_DLL_API BOOL __stdcall Dio_ReadIntrpt(HANDLE hBoard, ULONG* pIntrptData);									// 荞ݗvǂݏo
PIDIO_DLL_API BOOL __stdcall Dio_ReadInTransition(HANDLE hBoard, ULONG* pInTransiData1, ULONG* pInTransiData2);	// ͕ωǂݏo
PIDIO_DLL_API BOOL __stdcall Dio_ReadLatch(HANDLE hBoard, ULONG* pLatchData1, ULONG* pLatchData2);				// ̓b`f[^ǂݏo
PIDIO_DLL_API BOOL __stdcall Dio_ReadCurrentTimer(HANDLE hBoard, ULONG TimerNo, ULONG* pTimerValue, ULONG* pUnit);	// ^C}lǂݏo

// ̖̑
PIDIO_DLL_API BOOL __stdcall Dio_StartTimer(HANDLE hBoard, ULONG TimerNo, ULONG Mode);						// ^C}N
PIDIO_DLL_API BOOL __stdcall Dio_StopTimer(HANDLE hBoard, ULONG TimerNo, ULONG Mode);						// ^C}~
PIDIO_DLL_API BOOL __stdcall Dio_ClearInTransition(HANDLE hBoard);											// ͕ωNA
PIDIO_DLL_API BOOL __stdcall Dio_ExecSmlInLatch(HANDLE hBoard);												// ͓b`s
PIDIO_DLL_API BOOL __stdcall Dio_ExecSmlOut(HANDLE hBoard);													// o͓Zbgs

// G[R[h
PIDIO_DLL_API long __stdcall Dio_GetLastError();															// G[R[h擾
PIDIO_DLL_API void __stdcall Dio_ClearLastError();															// G[R[hNA


#endif	// _PIDIO_DLL_H_